package org.apache.bcel.generic;

import java.io.DataOutputStream;
import java.io.IOException;

public class JSR extends JsrInstruction implements VariableLengthInstruction {
   JSR() {
   }

   public JSR(InstructionHandle target) {
      super((short)168, target);
   }

   public void accept(Visitor v) {
      v.visitStackProducer(this);
      v.visitVariableLengthInstruction(this);
      v.visitBranchInstruction(this);
      v.visitJsrInstruction(this);
      v.visitJSR(this);
   }

   public void dump(DataOutputStream out) throws IOException {
      super.setIndex(this.getTargetOffset());
      if (super.getOpcode() == 168) {
         super.dump(out);
      } else {
         super.setIndex(this.getTargetOffset());
         out.writeByte(super.getOpcode());
         out.writeInt(super.getIndex());
      }

   }

   protected int updatePosition(int offset, int maxOffset) {
      int i = this.getTargetOffset();
      this.setPosition(this.getPosition() + offset);
      if (Math.abs(i) >= 32767 - maxOffset) {
         super.setOpcode((short)201);
         short oldLength = (short)super.getLength();
         super.setLength(5);
         return super.getLength() - oldLength;
      } else {
         return 0;
      }
   }
}
